
from BaseDataMaintenance.common.Utils import *
from tablestore import *

class BaseModel():

    def __init__(self):
        self.all_columns = []

    def getProperties(self):
        return self.__dict__

    def setProperties(self,k,v):
        if k in self.__dict__:
            self.__dict__[k] = v

    def getPrimary_keys(self):
        raise NotImplementedError

    def setValue(self,k,v,isColumn=False):
        if "all_columns" not in self.__dict__:
            self.all_columns = []
        self.__dict__[k] = v
        if isColumn:
            if k not in (set(self.all_columns)):
                self.all_columns.append(k)

    def getAll_columns(self):
        return list(self.__dict__.keys())

    def getAttribute_keys(self):
        return list(set(self.all_columns)-set(self.getPrimary_keys()))

    def getAttribute_turple(self):
        _list = []
        for _key in self.getAttribute_keys():
            _v = self.getProperties().get(_key)
            if _v is not None and _v!="":
                _list.append((_key,self.getProperties().get(_key)))
        return _list

    def getPrimaryKey_turple(self):
        _list = []
        for _key in self.getPrimary_keys():
            _list.append((_key,self.getProperties().get(_key)))
        return _list

    @staticmethod
    def search(ots_client,table_name,key_tuple,columns_to_get):
        try:
            # 调用get_row接口查询，最后一个参数值1表示只需要返回一个版本的值。
            consumed, return_row, next_token = ots_client.get_row(table_name, key_tuple, columns_to_get, None, 1)
            if return_row is not None:
                _dict = getRow_ots_primary(return_row)
                return _dict
            return None

        # 客户端异常，一般为参数错误或者网络异常。
        except OTSClientError as e:
            log("get row failed, http_status:%d, error_message:%s" % (e.get_http_status(), e.get_error_message()))
        # 服务端异常，一般为参数错误或者流控错误。
        except OTSServiceError as e:
            log("get row failed, http_status:%d, error_code:%s, error_message:%s, request_id:%s" % (e.get_http_status(), e.get_error_code(), e.get_error_message(), e.get_request_id()))

    def delete_row(self,ots_client):
        primary_key = self.getPrimaryKey_turple()
        row = Row(primary_key)
        try:
            consumed, return_row = ots_client.delete_row(self.table_name, row, None)
        except OTSClientError as e:
            log("update row failed, http_status:%d, error_message:%s" % (e.get_http_status(), e.get_error_message()))
            raise e
        # 服务端异常，一般为参数错误或者流控错误。
        except OTSServiceError as e:
            log("update row failed, http_status:%d, error_code:%s, error_message:%s, request_id:%s" % (e.get_http_status(), e.get_error_code(), e.get_error_message(), e.get_request_id()))
            raise e
        except Exception as e:
            raise e
        # log ('Delete succeed, consume %s write cu.' % consumed.write)

    def update_row(self,ots_client):
        primary_key = self.getPrimaryKey_turple()
        update_of_attribute_columns = {
            'PUT' : self.getAttribute_turple()
        }
        row = Row(primary_key,update_of_attribute_columns)
        condition = Condition('IGNORE')
        try:
            consumed, return_row = ots_client.update_row(self.table_name, row, condition)
        # 客户端异常，一般为参数错误或者网络异常。
        except OTSClientError as e:
            log("update row failed, http_status:%d, error_message:%s" % (e.get_http_status(), e.get_error_message()))
            raise e
        # 服务端异常，一般为参数错误或者流控错误。
        except OTSServiceError as e:
            log("update row failed, http_status:%d, error_code:%s, error_message:%s, request_id:%s" % (e.get_http_status(), e.get_error_code(), e.get_error_message(), e.get_request_id()))
            raise e
        except Exception as e:
            raise e
        # log ('update succeed, consume %s write cu.' % consumed.write)